package confutil;

/**
 * This class represents a configuration text message.
 * <p>Title: P2PWNC configuration utility</p>
 * <p>Description: Linksys WRT54GS P2PWNC configuration utility</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author pfrag
 * @version 1.0
 */
class ConfMsg {
  /**
   * Message type. This field can have one of the valid message types as specified in
   * the ConfClient class (that is, ACTION_GET, ACTION_ERR, ACTION_ACK, etc.)
   */
  protected int mtype;
  /**
   * Message text.
   */
  protected String mtext;

  /**
   * Default constructor. Constructs a null message.
   */
  ConfMsg() {
    this.mtype = 0;
    this.mtext = null;
  }

  /**
   * Constructs a ConfMsg using the specified input parameters.
   * @param mtype int
   * @param mtext String
   */
  ConfMsg(int mtype, String mtext) {
    this.mtype = mtype;
    this.mtext = new String(mtext);
  }

  /**
   * Returns the message's type.
   * @return int
   */
  public int getMessageType() {
    return this.mtype;
  }

  /**
   * Returns the actual text message.
   * @return String
   */
  public String getText() {
    return this.mtext;
  }

  /**
   * Sets the message type of the message to "mtype".
   * @param mtype int
   */
  public void setMessageType(int mtype) {
    this.mtype = mtype;
  }

  /**
   * Sets the message text to "text".
   * @param text String
   */
  public void setText(String text) {
    this.mtext = text;
  }
}
