package confutil;

import java.net.*;
import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;
import java.awt.event.*;
import javax.swing.event.ChangeEvent;
import java.io.*;
import com.borland.jbcl.layout.*;

class ConfUtil extends JFrame {
  protected ConfClient client;
  protected InetAddress serverAddr;
  protected String adminPasswd;

  JMenuBar mbMenuBar = new JMenuBar();
  JMenu mnuRouter = new JMenu();
  JMenuItem miPasswd = new JMenuItem();
  JMenuItem miAddr = new JMenuItem();
  JMenu mnuView = new JMenu();
  JMenuItem miCheckAll = new JMenuItem();
  JMenuItem miUncheckAll = new JMenuItem();
  JMenuItem miConfig = new JMenuItem();
  JMenuItem miMessages = new JMenuItem();
  JMenu mnuHelp = new JMenu();
  JMenuItem miAbout = new JMenuItem();
  JTabbedPane tabs = new JTabbedPane();
  JPanel configPanel = new JPanel();
  JPanel messagesPanel = new JPanel();
  JPanel statusPanel = new JPanel();
  JLabel lblStatus = new JLabel();
  BorderLayout borderLayout1 = new BorderLayout();
  Border border1;
  JTextField txtTcaIpAfddr = new JTextField();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();
  JLabel jLabel4 = new JLabel();
  JPanel jPanel1 = new JPanel();
  JCheckBox chkPublicKey = new JCheckBox();
  JTextField txtKeyPath = new JTextField();
  JButton btBrowse = new JButton();
  Border border2;
  JPanel jPanel2 = new JPanel();
  JPanel jPanel3 = new JPanel();
  JTextField txtSubnet = new JTextField();
  JCheckBox chkSubnet = new JCheckBox();
  JCheckBox chkMask = new JCheckBox();
  Border border3;
  TitledBorder titledBorder1;
  GridBagLayout gridBagLayout2 = new GridBagLayout();
  JCheckBox chkTCAAddr = new JCheckBox();
  JTextField txtMask = new JTextField();
  JPanel jPanel4 = new JPanel();
  JCheckBox chkMqKey = new JCheckBox();
  JTextField txtMqKey = new JTextField();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  Border border4;
  TitledBorder titledBorder2;
  GridBagLayout gridBagLayout3 = new GridBagLayout();
  Border border5;
  JLabel lblWithSelected = new JLabel();
  GridBagLayout gridBagLayout4 = new GridBagLayout();
  JPanel jPanel5 = new JPanel();
  JButton btSet = new JButton();
  JLabel jLabel5 = new JLabel();
  JButton btUnset = new JButton();
  Border border6;
  GridBagLayout gridBagLayout5 = new GridBagLayout();
  JMenuItem miGetVars = new JMenuItem();
  JScrollPane jScrollPane1 = new JScrollPane();
  JTextArea txtMessages = new JTextArea();
  JPanel jPanel6 = new JPanel();
  JCheckBox chkInitAp = new JCheckBox();
  Border border7;
  JCheckBox chkPort = new JCheckBox();
  JTextField txtSubnet2 = new JTextField();
  JTextField txtPort = new JTextField();
  JTextField txtIpt = new JTextField();
  JCheckBox chkIpt = new JCheckBox();
  Border border8;
  GridBagLayout gridBagLayout6 = new GridBagLayout();
  CardLayout cardLayout1 = new CardLayout();

  ConfUtil(){
    super("Linksys WRT54GS P2PWNC module configuration utility");
    try {
      serverAddr = InetAddress.getByName("192.168.1.1");
    }
    catch (java.net.UnknownHostException e) {
      //TODO: popup warning
      serverAddr = null;
      client = null;
      return;
    }
    client = new ConfClient(serverAddr);
    adminPasswd = null;
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public void retrieveValues() {
    Socket socket = null;

    //get variable values
    this.txtMask.setText(handleVariable(ConfClient.ACTION_GET, "p2pwnc_mask", null));
    this.txtMqKey.setText(handleVariable(ConfClient.ACTION_GET, "p2pwnc_mq_key", null));
    this.txtSubnet.setText(handleVariable(ConfClient.ACTION_GET, "p2pwnc_subnet", null));
    this.txtTcaIpAfddr.setText(handleVariable(ConfClient.ACTION_GET, "p2pwnc_repository_ip", null));
    if (handleVariable(ConfClient.ACTION_GET, "p2pwnc_init", null).compareToIgnoreCase("y") == 0) {
      this.chkInitAp.setSelected(true);
    }
    else {
      this.chkInitAp.setSelected(false);
    }
    this.txtPort.setText(handleVariable(ConfClient.ACTION_GET, "p2pwnc_port", null));
    this.txtIpt.setText(handleVariable(ConfClient.ACTION_GET, "p2pwnc_ipt_path", null));
    return;
  }


  public boolean authenticateUser(String passwd, Socket socket) {
    boolean authenticated = false;
    String text = null;
    ConfMsg msg = null;

    //send auth message to server
    text = client.makeMessage(ConfClient.ACTION_AUTH, passwd, null);
    if (text == null) {
      return false;
    }

    try {
      socket.getOutputStream().write(text.getBytes());
    }
    catch (IOException ex) {
      System.err.println("authenticateUser: Error writing to socket");
      return false;
    }

    //output text message to messages panel
    this.txtMessages.append(text + "\r\n\r\n");

    //read server response
    msg = client.readMessage(socket);
    if (msg == null) {
      return false;
    }

    this.txtMessages.append(msg.getText() + "\r\n\r\n");

    if (msg.mtype != ConfClient.ACTION_AUTH_OK) {
      System.err.println("!AOK");
      return false;
    }
    else {
      return true;
    }
  }

  //gets, sets or unsets a variable
  public String handleVariable(int action, String var, String val) {
    String text = null;
    ConfMsg msg = null;
    String retval = null;

    //connect to server
    Socket socket = this.client.connectToServer();
    if (socket == null) {
      System.err.println("retrieveValues: Error connecting to server");
      return null;
    }

    //authenticate client
    if (!this.authenticateUser(this.adminPasswd, socket)) {
      System.err.println("retrieveValues: Error authenticating user");
      try {
        socket.close();
      }
      catch (IOException ioe) {
        System.err.println("retrieveValues: Could not close socket");
      }
      return null;
    }

    //make message
    text = this.client.makeMessage(action, var, val);
    if (text == null) {
      System.err.println("getVariableValue: Error constructing text message");
      try {
        socket.close();
      }
      catch (IOException ioe) {
        System.err.println("retrieveValues: Could not close socket");
      }
      return null;
    }

    //output message to "Messages" tab
    this.txtMessages.append(text + "\r\n\r\n");

    //send message
    try {
      socket.getOutputStream().write(text.getBytes());
    }
    catch (IOException ex) {
      System.err.println("getVariableValue: Error writing to socket");
      try {
        socket.close();
      }
      catch (IOException ioe) {
        System.err.println("retrieveValues: Could not close socket");
      }
      return null;
    }

    //read response
    msg = this.client.readMessage(socket);
    this.txtMessages.append(msg.getText() + "\r\n\r\n");

    if (msg == null) {
      System.err.println("getVariableValue: Error reading server response");
      try {
        socket.close();
      }
      catch (IOException ioe) {
        System.err.println("retrieveValues: Could not close socket");
      }
      return null;
    }
    else
    if (msg.mtype == ConfClient.ACTION_ERR) {
      System.err.println("getVariableValue: Error getting variable value - " + var);
      try {
        socket.close();
      }
      catch (IOException ioe) {
        System.err.println("retrieveValues: Could not close socket");
      }
      return null;
    }
    else
    if (msg.mtype == ConfClient.ACTION_ACK) {
      try {
        socket.close();
      }
      catch (IOException ioe) {
        System.err.println("retrieveValues: Could not close socket");
      }
      return client.parseMessage(msg.mtext);
    }
    else {
      System.err.println("getVariableValue: Invalid response message");
      try {
        socket.close();
      }
      catch (IOException ioe) {
        System.err.println("retrieveValues: Could not close socket");
      }
      return null;
    }
  }

  public static void main(String[] args){
    ConfUtil confUtilWnd = new ConfUtil();
    confUtilWnd.setSize(500, 500);
    confUtilWnd.setResizable(false);
    confUtilWnd.show();
  }

  private void jbInit() throws Exception {
    border1 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(165, 163, 151));
    border2 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(165, 163, 151)),"Team Public Key");
    border3 = BorderFactory.createBevelBorder(BevelBorder.RAISED,Color.white,Color.white,new Color(115, 114, 105),new Color(165, 163, 151));
    titledBorder1 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(165, 163, 151)),"Networking");
    border4 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(165, 163, 151));
    titledBorder2 = new TitledBorder(border4,"Message Queue");
    border5 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(165, 163, 151));
    border6 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(165, 163, 151));
    border7 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(165, 163, 151));
    border8 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(165, 163, 151)),"iptables path");
    this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
    this.setJMenuBar(mbMenuBar);
    mnuRouter.setText("Router");
    miAddr.setText("IP address");
    miAddr.addActionListener(new ConfUtil_miAddr_actionAdapter(this));
    mnuView.setText("View");
    miCheckAll.setText("Check All");
    miCheckAll.addActionListener(new ConfUtil_miCheckAll_actionAdapter(this));
    miUncheckAll.setText("Uncheck All");
    miUncheckAll.addActionListener(new ConfUtil_miUncheckAll_actionAdapter(this));
    miConfig.setText("Configuration");
    miConfig.addActionListener(new ConfUtil_miConfig_actionAdapter(this));
    miMessages.setText("Messages");
    miMessages.addActionListener(new ConfUtil_miMessages_actionAdapter(this));
    mnuHelp.setText("Help");
    miAbout.setText("About");
    miPasswd.setText("Administrator password");
    miPasswd.addActionListener(new ConfUtil_miPasswd_actionAdapter(this));
    lblStatus.setAlignmentX((float) 0.0);
    lblStatus.setBorder(null);
    lblStatus.setToolTipText("");
    lblStatus.setHorizontalAlignment(SwingConstants.LEFT);
    lblStatus.setHorizontalTextPosition(SwingConstants.LEFT);
    lblStatus.setText(" ");
    lblStatus.setVerticalAlignment(javax.swing.SwingConstants.CENTER);
    lblStatus.setVerticalTextPosition(javax.swing.SwingConstants.CENTER);
    statusPanel.setLayout(borderLayout1);
    configPanel.setLayout(gridBagLayout5);
    txtTcaIpAfddr.setSelectionStart(11);
    txtTcaIpAfddr.setText("");
    txtTcaIpAfddr.addActionListener(new ConfUtil_jTextField4_actionAdapter(this));
    jLabel4.setText("");
    jLabel3.setText("");
    jLabel2.setText("");
    jLabel1.setText("");
    chkPublicKey.setActionCommand("chkPublicKey");
    chkPublicKey.addActionListener(new ConfUtil_chkPublicKey_actionAdapter(this));
    chkPublicKey.addActionListener(new ConfUtil_chkPublicKey_actionAdapter(this));
    txtKeyPath.setText("");
    txtKeyPath.addActionListener(new ConfUtil_jTextField5_actionAdapter(this));
    txtKeyPath.addActionListener(new ConfUtil_jTextField5_actionAdapter(this));
    btBrowse.setActionCommand("btBrowse");
    btBrowse.setText("Browse");
    btBrowse.addActionListener(new ConfUtil_btBrowse_actionAdapter(this));
    jPanel1.setBorder(border2);
    jPanel1.setLayout(gridBagLayout3);
    txtSubnet.setText("");
    txtSubnet.addActionListener(new ConfUtil_jTextField3_actionAdapter(this));
    chkSubnet.setActionCommand("chkSubnet");
    chkSubnet.setSelectedIcon(null);
    chkSubnet.setText("Subnet");
    chkSubnet.addActionListener(new ConfUtil_chkSubnet_actionAdapter(this));
    chkMask.setActionCommand("chkMask");
    chkMask.setText("Mask");
    chkMask.addActionListener(new ConfUtil_chkMask_actionAdapter(this));
    jPanel3.setBorder(titledBorder1);
    jPanel3.setLayout(gridBagLayout2);
    chkTCAAddr.setActionCommand("chkTCAAddr");
    chkTCAAddr.setText("Repository Address");
    chkTCAAddr.addActionListener(new ConfUtil_chkTCAAddr_actionAdapter(this));
    txtMask.setText("");
    chkMqKey.setActionCommand("chkMqKey");
    chkMqKey.setText("Key");
    chkMqKey.addActionListener(new ConfUtil_chkMqKey_actionAdapter(this));
    txtMqKey.setText("");
    jPanel4.setLayout(gridBagLayout1);
    jPanel4.setBorder(titledBorder2);
    lblWithSelected.setText("With Selected:");
    jPanel5.setLayout(gridBagLayout4);
    btSet.setActionCommand("Set");
    btSet.setText("Set");
    btSet.addActionListener(new ConfUtil_btSet_actionAdapter(this));
    jLabel5.setText("");
    btUnset.setActionCommand("Unset");
    btUnset.setText("Unset");
    btUnset.addActionListener(new ConfUtil_btUnset_actionAdapter(this));
    miGetVars.setText("Get Variables");
    miGetVars.addActionListener(new ConfUtil_miGetVars_actionAdapter(this));
    messagesPanel.setLayout(cardLayout1);
    txtMessages.setEditable(false);
    chkInitAp.addActionListener(new ConfUtil_chkInitAp_actionAdapter(this));
    chkInitAp.addActionListener(new ConfUtil_chkInitAp_actionAdapter(this));
    chkInitAp.setActionCommand("chkPublicKey");
    chkInitAp.setText("Run on router start-up");
    chkInitAp.addActionListener(new ConfUtil_chkInitAp_actionAdapter(this));
    jPanel6.setAlignmentX((float) 0.5);
    jPanel6.setBorder(border7);
    chkPort.setText("Server Port");
    chkPort.addActionListener(new ConfUtil_chkPort_actionAdapter(this));
    chkPort.setSelectedIcon(null);
    chkPort.setActionCommand("chkPort");
    txtSubnet2.setText("");
    txtSubnet2.addActionListener(new ConfUtil_jTextField3_actionAdapter(this));
    txtPort.addActionListener(new ConfUtil_jTextField4_actionAdapter(this));
    txtPort.setText("");
    txtPort.setSelectionStart(11);
    txtIpt.addActionListener(new ConfUtil_jTextField5_actionAdapter(this));
    txtIpt.addActionListener(new ConfUtil_jTextField5_actionAdapter(this));
    txtIpt.setText("");
    chkIpt.addActionListener(new ConfUtil_chkIpt_actionAdapter(this));
    chkIpt.addActionListener(new ConfUtil_chkIpt_actionAdapter(this));
    chkIpt.setActionCommand("chkIpt");
    chkIpt.addActionListener(new ConfUtil_chkIpt_actionAdapter(this));
    jPanel2.setBorder(border8);
    jPanel2.setLayout(gridBagLayout6);
    mbMenuBar.add(mnuRouter);
    mbMenuBar.add(mnuView);
    mbMenuBar.add(mnuHelp);
    mnuRouter.add(miPasswd);
    mnuRouter.add(miAddr);
    mnuRouter.add(miGetVars);
    mnuView.add(miCheckAll);
    mnuView.add(miUncheckAll);
    mnuView.add(miConfig);
    mnuView.add(miMessages);
    mnuHelp.add(miAbout);
    this.getContentPane().add(tabs, BorderLayout.CENTER);
    tabs.add(configPanel,  "Configuration");
    jPanel5.add(btUnset,                 new GridBagConstraints(3, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.SOUTHEAST, GridBagConstraints.NONE, new Insets(10, 10, 10, 10), 35, 0));
    jPanel5.add(jLabel5,                new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel5.add(lblWithSelected,         new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(11, 6, 9, 0), 43, 0));
    jPanel5.add(btSet,      new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(10, 0, 10, 10), 63, 0));
    configPanel.add(jLabel4,          new GridBagConstraints(0, 1, 1, GridBagConstraints.REMAINDER, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 5), 489, 0));
    configPanel.add(jLabel3,          new GridBagConstraints(0, 2, 1, GridBagConstraints.REMAINDER, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 5, 0, 5), 489, 0));
    configPanel.add(jLabel2,          new GridBagConstraints(0, 3, 1, GridBagConstraints.REMAINDER, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 5, 0, 5), 489, 0));
    configPanel.add(jLabel1,          new GridBagConstraints(0, 4, 1, GridBagConstraints.REMAINDER, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 5, 0, 5), 489, 0));
    configPanel.add(jPanel3,          new GridBagConstraints(0, 4, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 5, 0, 5), 229, 0));
    jPanel1.add(chkPublicKey,     new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(4, 7, 6, 24), 0, 0));
    jPanel1.add(txtKeyPath, new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(4, -15, 6, 15), 0, 0));
    jPanel1.add(btBrowse,     new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(3, 6, 7, 176), 0, 0));
    configPanel.add(jPanel6,                new GridBagConstraints(0, 8, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 7, 0, 8), 348, 0));
    jPanel6.add(chkInitAp, null);
    configPanel.add(jPanel5,           new GridBagConstraints(0, 9, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 5, 0, 5), 245, 0));
    configPanel.add(jPanel4,          new GridBagConstraints(0, 5, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 5, 0, 5), 194, 0));
    jPanel4.add(chkMqKey,   new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel4.add(txtMqKey,               new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 9, 5, 164), 54, 0));
    configPanel.add(jPanel2,               new GridBagConstraints(0, 6, 1, 1, 1.0, 1.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(0, 5, 0, 5), 0, 0));
    jPanel2.add(chkIpt,   new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(4, 4, 1, 0), 0, 0));
    jPanel2.add(txtIpt,              new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(3, 28, 2, 2), 189, 0));
    jPanel3.add(chkSubnet,                                     new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    jPanel3.add(chkMask,                                     new GridBagConstraints(0, 1, 3, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 61, 0));
    jPanel3.add(chkTCAAddr,                                    new GridBagConstraints(0, 2, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel3.add(txtSubnet,                    new GridBagConstraints(3, 0, 2, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 115, 0));
    jPanel3.add(txtMask,                   new GridBagConstraints(3, 1, 2, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 115, 0));
    jPanel3.add(txtTcaIpAfddr,                   new GridBagConstraints(3, 2, 1, 2, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 0), 115, 0));
    jPanel3.add(chkPort,      new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel3.add(txtPort,      new GridBagConstraints(3, 4, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 0), 0, 0));
    configPanel.add(jPanel1,          new GridBagConstraints(0, 7, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 5, 0, 5), 161, 0));
    tabs.add(messagesPanel,   "Messages");
    this.getContentPane().add(statusPanel, BorderLayout.SOUTH);
    statusPanel.add(lblStatus, BorderLayout.WEST);
    messagesPanel.add(jScrollPane1, "jScrollPane1");
    jScrollPane1.getViewport().add(txtMessages, null);
  }

  public void miCheckAll_actionPerformed(ActionEvent e) {
    this.chkMask.setSelected(true);
    this.chkMqKey.setSelected(true);
    this.chkPublicKey.setSelected(true);
    this.chkSubnet.setSelected(true);
    this.chkTCAAddr.setSelected(true);
    this.chkIpt.setSelected(true);
    this.chkPort.setSelected(true);

    this.txtKeyPath.setEnabled(true);
    this.txtMask.setEnabled(true);
    this.txtMqKey.setEnabled(true);
    this.txtSubnet.setEnabled(true);
    this.txtTcaIpAfddr.setEnabled(true);
    this.btBrowse.setEnabled(true);
    this.btSet.setEnabled(true);
    this.btUnset.setEnabled(true);
    this.txtIpt.setEnabled(true);
    this.txtPort.setEnabled(true);
  }

  public void miUncheckAll_actionPerformed(ActionEvent e) {
    this.chkMask.setSelected(false);
    this.chkMqKey.setSelected(false);
    this.chkPublicKey.setSelected(false);
    this.chkSubnet.setSelected(false);
    this.chkTCAAddr.setSelected(false);
    this.chkIpt.setSelected(false);
    this.chkPort.setSelected(false);

    this.txtKeyPath.setEnabled(false);
    this.txtMask.setEnabled(false);
    this.txtMqKey.setEnabled(false);
    this.txtSubnet.setEnabled(false);
    this.txtTcaIpAfddr.setEnabled(false);
    this.btBrowse.setEnabled(false);
    this.btSet.setEnabled(false);
    this.btUnset.setEnabled(false);
    this.txtIpt.setEnabled(false);
    this.txtPort.setEnabled(false);
  }

  public void miConfig_actionPerformed(ActionEvent e) {
    this.tabs.setSelectedIndex(0);
  }

  public void miMessages_actionPerformed(ActionEvent e) {
    this.tabs.setSelectedIndex(1);
  }

  public void chkPublicKey_stateChanged(ChangeEvent e) {
    JCheckBox current = null;

    if (!(e.getSource() instanceof JCheckBox)) {
      return;
    }
    current = (JCheckBox)e.getSource();
    if ( !current.getActionCommand().equals("chkPublicKey") ) {
      return;
    }
    if ( current.isSelected() ) {
      this.txtKeyPath.setEnabled(true);
      this.btBrowse.setEnabled(true);
    }
    else {
      this.txtKeyPath.setEnabled(true);
      this.btBrowse.setEnabled(true);
    }
  }

  public void chkPublicKey_actionPerformed(ActionEvent e) {
    JCheckBox current = null;

    if (!(e.getSource() instanceof JCheckBox)) {
      return;
    }
    current = (JCheckBox)e.getSource();

    if ( !current.getActionCommand().equals("chkPublicKey") ) {
      return;
    }
    if ( current.isSelected() ) {
      this.txtKeyPath.setEnabled(true);
      this.btBrowse.setEnabled(true);
    }
    else {
      this.txtKeyPath.setEnabled(false);
      this.btBrowse.setEnabled(false);
    }

  }

  public void chkMqKey_actionPerformed(ActionEvent e) {
    JCheckBox current = null;

    if (!(e.getSource() instanceof JCheckBox)) {
      return;
    }
    current = (JCheckBox)e.getSource();

    if ( !current.getActionCommand().equals("chkMqKey") ) {
      return;
    }
    if ( current.isSelected() ) {
      this.txtMqKey.setEnabled(true);
    }
    else {
      this.txtMqKey.setEnabled(false);
    }
  }

  public void chkTCAAddr_actionPerformed(ActionEvent e) {
    JCheckBox current = null;

    if (!(e.getSource() instanceof JCheckBox)) {
      return;
    }
    current = (JCheckBox)e.getSource();

    if ( !current.getActionCommand().equals("chkTCAAddr") ) {
      return;
    }
    if ( current.isSelected() ) {
      this.txtTcaIpAfddr.setEnabled(true);
    }
    else {
      this.txtTcaIpAfddr.setEnabled(false);
    }

  }

  public void chkMask_actionPerformed(ActionEvent e) {
    JCheckBox current = null;

    if (!(e.getSource() instanceof JCheckBox)) {
      return;
    }
    current = (JCheckBox)e.getSource();

    if ( !current.getActionCommand().equals("chkMask") ) {
      return;
    }
    if ( current.isSelected() ) {
      this.txtMask.setEnabled(true);
    }
    else {
      this.txtMask.setEnabled(false);
    }

  }

  public void chkSubnet_actionPerformed(ActionEvent e) {
    JCheckBox current = null;

    if (!(e.getSource() instanceof JCheckBox)) {
      return;
    }
    current = (JCheckBox)e.getSource();

    if ( !current.getActionCommand().equals("chkSubnet") ) {
      return;
    }
    if ( current.isSelected() ) {
      this.txtSubnet.setEnabled(true);
    }
    else {
      this.txtSubnet.setEnabled(false);
    }
  }

  public void miAddr_actionPerformed(ActionEvent e) {
    InputBox ib = new InputBox(this, this.getTitle(), true, this.serverAddr.getHostName(), "Router IP Address", false);
    InetAddress tempServerAddr = null;
    ib.show();
    try {
      tempServerAddr = InetAddress.getByName(ib.getInput());
    }
    catch (java.net.UnknownHostException uhe) {
      MessageBox mb = new MessageBox(this, this.getTitle(), true, "Invalid IP address", MessageBox.MB_OK);
      mb.show();
      return;
    }
    serverAddr = tempServerAddr;
    this.client = new ConfClient(serverAddr);
    ib.dispose();
  }

  public void miPasswd_actionPerformed(ActionEvent e) {
    InputBox ib = new InputBox(this, this.getTitle(), true, adminPasswd, "Administrator Password", true);
    ib.show();
    this.adminPasswd = ib.getInput();
    ib.dispose();
  }

  void btSet_actionPerformed(ActionEvent e) {
    if (this.chkMask.isSelected()) {
      this.handleVariable(ConfClient.ACTION_SET, "p2pwnc_mask", this.txtMask.getText());
    }

    if (this.chkMqKey.isSelected()) {
      this.handleVariable(ConfClient.ACTION_SET, "p2pwnc_mq_key", this.txtMqKey.getText());
    }

    if (this.chkSubnet.isSelected()) {
      this.handleVariable(ConfClient.ACTION_SET, "p2pwnc_subnet", this.txtSubnet.getText());
    }

    if (this.chkTCAAddr.isSelected()) {
      this.handleVariable(ConfClient.ACTION_SET, "p2pwnc_repository_ip", this.txtTcaIpAfddr.getText());
    }

    if (this.chkPort.isSelected()) {
      this.handleVariable(ConfClient.ACTION_SET, "p2pwnc_port", this.txtPort.getText());
    }

    if (this.chkIpt.isSelected()) {
      this.handleVariable(ConfClient.ACTION_SET, "p2pwnc_ipt_path", this.txtIpt.getText());
    }

    if (this.chkInitAp.isSelected()) {
      this.handleVariable(ConfClient.ACTION_SET, "p2pwnc_init", "y");
    }
    else {
      this.handleVariable(ConfClient.ACTION_SET, "p2pwnc_init", "n");
    }


    //public key: open file, read contents, send message
    String keyContent = null;
    if (this.chkPublicKey.isSelected()) {
      keyContent = this.readPublicKey(this.txtKeyPath.getText());
      if (keyContent != null) {
        this.handleVariable(ConfClient.ACTION_SET, "p2pwnc_ap_pub", keyContent);
      }
    }
  }

  void btUnset_actionPerformed(ActionEvent e) {
    if (this.chkMask.isSelected()) {
      if (this.handleVariable(ConfClient.ACTION_UNSET, "p2pwnc_mask", null) != null) {
        this.txtMask.setText("");
      }
    }

    if (this.chkMqKey.isSelected()) {
      if (this.handleVariable(ConfClient.ACTION_UNSET, "p2pwnc_mq_key", null) != null) {
        this.txtMqKey.setText("");
      }
    }

    if (this.chkSubnet.isSelected()) {
      if (this.handleVariable(ConfClient.ACTION_UNSET, "p2pwnc_subnet", null) != null) {
        this.txtSubnet.setText(null);
      }
    }

    if (this.chkTCAAddr.isSelected()) {
      if (this.handleVariable(ConfClient.ACTION_UNSET, "p2pwnc_repository_ip", null) != null) {
        this.txtTcaIpAfddr.setText("");
      }
    }

    if (this.chkPublicKey.isSelected()) {
      if (this.handleVariable(ConfClient.ACTION_UNSET, "p2pwnc_ap_pub", null) != null) {
        this.txtKeyPath.setText("");
      }
    }

    if (this.chkPort.isSelected()) {
      this.handleVariable(ConfClient.ACTION_UNSET, "p2pwnc_port", this.txtPort.getText());
      this.txtPort.setText("");
    }

    if (this.chkIpt.isSelected()) {
      this.handleVariable(ConfClient.ACTION_UNSET, "p2pwnc_ipt_path", this.txtIpt.getText());
      this.txtIpt.setText("");
    }

  }

  void miGetVars_actionPerformed(ActionEvent e) {
    this.retrieveValues();
  }

  void btBrowse_actionPerformed(ActionEvent e) {
    JFileChooser fc = new JFileChooser();
    fc.setMultiSelectionEnabled(false);
    fc.showOpenDialog(this);
    if (fc.getSelectedFile() != null) {
      this.txtKeyPath.setText(fc.getSelectedFile().getAbsolutePath());
    }
  }



  public String readPublicKey(String path) {
    BufferedReader reader;
    String line = null;
    StringBuffer text = new StringBuffer();

    try {
      reader = new BufferedReader(new FileReader(path));
    }
    catch (FileNotFoundException e) {
      System.err.println("readPublicKey: File not found");
      return null;
    }

    try {
      //read first line: algorithm + bits
      if ( (line = reader.readLine()) != null) {
        if (line.substring(0, 3).compareToIgnoreCase("RSA") != 0) {
          if (line.substring(0, 3).compareToIgnoreCase("ECC") != 0) {
            System.err.println("readPublicKey: Invalid algorithm name or no algorithm identifier");
            reader.close();
            return null;
          }
        }
      }
      while ( (line = reader.readLine()) != null) {
        if (line.length() != 0) {
          text.append(line);
        }
        else {
          break;
        }
      }
    }
    catch (IOException e) {
      System.err.println("reaqPublicKey: Error reading file");
      return null;
    }

    try {
      reader.close();
    }
    catch (IOException e) {
      System.err.println("readPublicKey: Error closing input file");
      return null;
    }
    return text.toString();
  }

  void chkIpt_actionPerformed(ActionEvent e) {
    JCheckBox current = null;

    if (!(e.getSource() instanceof JCheckBox)) {
      return;
    }
    current = (JCheckBox)e.getSource();

    if ( !current.getActionCommand().equals("chkIpt") ) {
      return;
    }
    if ( current.isSelected() ) {
      this.txtIpt.setEnabled(true);
    }
    else {
      this.txtIpt.setEnabled(false);
    }
  }

  void chkInitAp_actionPerformed(ActionEvent e) {

  }

  void chkPort_actionPerformed(ActionEvent e) {

  }
}

class ConfUtil_miPasswd_actionAdapter
    implements ActionListener {
  private ConfUtil adaptee;
  ConfUtil_miPasswd_actionAdapter(ConfUtil adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.miPasswd_actionPerformed(e);
  }
}

class ConfUtil_miAddr_actionAdapter
    implements ActionListener {
  private ConfUtil adaptee;
  ConfUtil_miAddr_actionAdapter(ConfUtil adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.miAddr_actionPerformed(e);
  }
}

class ConfUtil_chkSubnet_actionAdapter
    implements ActionListener {
  private ConfUtil adaptee;
  ConfUtil_chkSubnet_actionAdapter(ConfUtil adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.chkSubnet_actionPerformed(e);
  }
}

class ConfUtil_chkMask_actionAdapter
    implements ActionListener {
  private ConfUtil adaptee;
  ConfUtil_chkMask_actionAdapter(ConfUtil adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.chkMask_actionPerformed(e);
  }
}

class ConfUtil_chkTCAAddr_actionAdapter
    implements ActionListener {
  private ConfUtil adaptee;
  ConfUtil_chkTCAAddr_actionAdapter(ConfUtil adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.chkTCAAddr_actionPerformed(e);
  }
}

class ConfUtil_miMessages_actionAdapter
    implements ActionListener {
  private ConfUtil adaptee;
  ConfUtil_miMessages_actionAdapter(ConfUtil adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.miMessages_actionPerformed(e);
  }
}

class ConfUtil_miCheckAll_actionAdapter
    implements ActionListener {
  private ConfUtil adaptee;
  ConfUtil_miCheckAll_actionAdapter(ConfUtil adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.miCheckAll_actionPerformed(e);
  }
}

class ConfUtil_miConfig_actionAdapter
    implements ActionListener {
  private ConfUtil adaptee;
  ConfUtil_miConfig_actionAdapter(ConfUtil adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.miConfig_actionPerformed(e);
  }
}

class ConfUtil_miUncheckAll_actionAdapter
    implements ActionListener {
  private ConfUtil adaptee;
  ConfUtil_miUncheckAll_actionAdapter(ConfUtil adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.miUncheckAll_actionPerformed(e);
  }
}

class ConfUtil_chkPublicKey_actionAdapter implements java.awt.event.ActionListener {
  ConfUtil adaptee;

  ConfUtil_chkPublicKey_actionAdapter(ConfUtil adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.chkPublicKey_actionPerformed(e);

  }
}

class ConfUtil_chkMqKey_actionAdapter
    implements ActionListener {
  private ConfUtil adaptee;
  ConfUtil_chkMqKey_actionAdapter(ConfUtil adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.chkMqKey_actionPerformed(e);
  }
}

class ConfUtil_jTextField5_actionAdapter implements java.awt.event.ActionListener {
  ConfUtil adaptee;

  ConfUtil_jTextField5_actionAdapter(ConfUtil adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {

  }
}

class ConfUtil_jTextField4_actionAdapter implements java.awt.event.ActionListener {
  ConfUtil adaptee;

  ConfUtil_jTextField4_actionAdapter(ConfUtil adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {

  }
}

class ConfUtil_jTextField3_actionAdapter implements java.awt.event.ActionListener {
  ConfUtil adaptee;

  ConfUtil_jTextField3_actionAdapter(ConfUtil adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {

  }
}

class ConfUtil_btSet_actionAdapter implements java.awt.event.ActionListener {
  ConfUtil adaptee;

  ConfUtil_btSet_actionAdapter(ConfUtil adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btSet_actionPerformed(e);
  }
}

class ConfUtil_btUnset_actionAdapter implements java.awt.event.ActionListener {
  ConfUtil adaptee;

  ConfUtil_btUnset_actionAdapter(ConfUtil adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btUnset_actionPerformed(e);
  }
}

class ConfUtil_miGetVars_actionAdapter implements java.awt.event.ActionListener {
  ConfUtil adaptee;

  ConfUtil_miGetVars_actionAdapter(ConfUtil adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.miGetVars_actionPerformed(e);
  }
}

class ConfUtil_btBrowse_actionAdapter implements java.awt.event.ActionListener {
  ConfUtil adaptee;

  ConfUtil_btBrowse_actionAdapter(ConfUtil adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.btBrowse_actionPerformed(e);
  }
}

class ConfUtil_chkInitAp_actionAdapter implements java.awt.event.ActionListener {
  ConfUtil adaptee;

  ConfUtil_chkInitAp_actionAdapter(ConfUtil adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.chkInitAp_actionPerformed(e);
  }
}

class ConfUtil_chkIpt_actionAdapter implements java.awt.event.ActionListener {
  ConfUtil adaptee;

  ConfUtil_chkIpt_actionAdapter(ConfUtil adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.chkIpt_actionPerformed(e);
  }
}

class ConfUtil_chkPort_actionAdapter implements java.awt.event.ActionListener {
  ConfUtil adaptee;

  ConfUtil_chkPort_actionAdapter(ConfUtil adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.chkPort_actionPerformed(e);
  }
}
