package confutil;

import java.awt.*;
import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class InputBox
    extends JDialog {

  protected String strInput;
  protected String strMessage;

  public String getInput() {
    return this.strInput;
  }

  public String getMessage() {
    return this.strMessage;
  }

  public void setInput(String inp) {
    this.strInput = inp;
  }

  public void setMessage(String msg) {
    this.strMessage = msg;
  }

  public InputBox(Dialog owner, String title, boolean modal, String input, String message, boolean isPasswd){
    super(owner, title, modal);
    this.strInput = input;
    this.strMessage = message;
    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }

    this.strInput = input;
    this.strMessage = message;
    this.txtInput.setText(input);
    this.lblMessage.setText(message);

    if (isPasswd) {
      txtInput.setEchoChar('*');
    }
    else {
      txtInput.setEchoChar((char)0);
    }
  }

  public InputBox(Frame owner, String title, boolean modal, String input, String message, boolean isPasswd) {
    super(owner, title, modal);
    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
    this.strInput = input;
    this.strMessage = message;
    this.txtInput.setText(input);
    this.lblMessage.setText(message);

    if (isPasswd) {
      txtInput.setEchoChar('*');
    }
    else {
      txtInput.setEchoChar((char)0);
    }
  }


  private void jbInit() throws Exception {
    txtInput.setText("");
    txtInput.setBounds(new Rectangle(5, 43, 165, 21));
    btOk.setBounds(new Rectangle(6, 83, 73, 25));
    btOk.setText("OK");
    btOk.addActionListener(new InputBox_btOk_actionAdapter(this));
    btCancel.setBounds(new Rectangle(93, 83, 73, 25));
    btCancel.setText("Cancel");
    btCancel.addActionListener(new InputBox_btCancel_actionAdapter(this));
    jPanel1.setPreferredSize(new Dimension(100, 100));
    this.getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);
    jPanel1.add(lblMessage);
    jPanel1.add(txtInput);
    jPanel1.add(btOk);
    jPanel1.add(btCancel);
    lblMessage.setText("");
    lblMessage.setBounds(new Rectangle(6, 6, 320, 35));
    jPanel1.setLayout(null);
    this.setSize(180,150);
    this.setResizable(false);
  }

  JPanel jPanel1 = new JPanel();
  JLabel lblMessage = new JLabel();
  JPasswordField txtInput = new JPasswordField();
  JButton btOk = new JButton();
  JButton btCancel = new JButton();
  public void btOk_actionPerformed(ActionEvent e) {
    this.strInput = txtInput.getText();
    this.hide();
  }

  public void btCancel_actionPerformed(ActionEvent e) {
    this.hide();
  }
}

class InputBox_btCancel_actionAdapter
    implements ActionListener {
  private InputBox adaptee;
  InputBox_btCancel_actionAdapter(InputBox adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.btCancel_actionPerformed(e);
  }
}

class InputBox_btOk_actionAdapter
    implements ActionListener {
  private InputBox adaptee;
  InputBox_btOk_actionAdapter(InputBox adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.btOk_actionPerformed(e);
  }
}
